require 'studio_game/clumsy_player'
require 'studio_game/player'
require 'studio_game/treasure_trove'

module StudioGame
	describe ClumsyPlayer do 
		before do
			$stdout = StringIO.new
			@initial_health = 100
			@health_bonus = 20
			@player = ClumsyPlayer.new("klumsy", @initial_health)
		end
		it "gets half the points for treasures" do
			@player.points.should == 0

			hammer = Treasure.new(:hammer, 50)
			@player.found_treasure(hammer)
			@player.found_treasure(hammer)
			@player.found_treasure(hammer)
			
			@player.points.should == 75

			crowbar = Treasure.new(:crowbar, 400)
			@player.found_treasure(crowbar)

			@player.points.should == 275

			yielded = []
			@player.each_found_treasure do |treasure|
				yielded << treasure
			end

			yielded.should == [Treasure.new(:hammer, 75), Treasure.new(:crowbar, 200)]
		end

		it "gets extra health when w00ted" do
			2.times { @player.w00t }
			@player.health.should == @initial_health + 30 + (@health_bonus * 2)
		end
	end
end